//the font class builds a font and then allows the use of it by drawing and providing a string

#include "Font.h"

//we "create" our font using all of the parameters, the most important being the first (size) and last
//(font face)
LOGFONT LogFont = {28,0,0,0,FW_NORMAL,false,false,false,DEFAULT_CHARSET,
				   OUT_TT_PRECIS,CLIP_DEFAULT_PRECIS,PROOF_QUALITY,DEFAULT_PITCH,"Times New Roman"};

//for drawing we take the actual text, an x and y value, and a direct3d color
void Font::Draw(LPSTR text, float x, float y, D3DCOLOR rgbColor)
{
    pos.top = y;
	pos.left = x;
	pos.right = 0;
	pos.bottom = 0;
	//you must begin before you draw. however if you are drawing many times in a row you should do this before outside of the class
	//and then end after the drawing you do
	app_Font->Begin(); 
	app_Font->DrawText(text,-1,&pos,DT_CENTER,rgbColor);  //the fonts actual draw takes the string, the vector positon, the justification and color
	app_Font->End();
}
Font::Font()
{
}

//this is where we actually load the font (logfont) into a directx font object. the create takes the application device, the logfont and the d3dxfont object
void Font::load(LPDIRECT3DDEVICE8 app_device)
{
	blinking = 0;
	D3DXCreateFontIndirect(app_device,&LogFont,&app_Font);
}

//a very rudimentary way to make font blink. we just increment the blink and return the new value
//you an base the blinking speed off of the blink value
int Font::blink(int time)
{
	blinking += time;
	return blinking;
}

//make sure to release the font when we are done with it
Font::~Font()
{
	if(app_Font) //we check if the objecgt is valid at first, then set it to null to be safe
	{
	   app_Font->Release();	//release font
	   app_Font = NULL;
	}
}
