//they keyboard class create a directinput object and allows you to create a keyboard input device

#include "Keyboard.h"

Keyboard::Keyboard()
{
}

//in order to load they keyboard there is a few things we must do first. all of this is done in the load function
void Keyboard::load(HWND h_hwndMain) 
{
	HRESULT hr;

	//first we create the dinpute device using the app instance, the dinput version, our interface, a pointer to our dinput device
	DirectInput8Create(GetModuleHandle(NULL), DIRECTINPUT_VERSION, 
        IID_IDirectInput8, (void **)&dInput, NULL); 

	//then we create the keyboard device using the dinput with paremeters of the sys keyboard and a pointer to our keyboard object
	dInput->CreateDevice(GUID_SysKeyboard, &dKeyboard, NULL);   

	hr = dKeyboard->SetDataFormat(&c_dfDIKeyboard);   //to set the format pass the predefine keyboard format
	if FAILED(hr)
	{ 
	} 

	hr = dKeyboard->SetCooperativeLevel(h_hwndMain,    //set when an how the device works. it is in our window when it is in the foreground
		DISCL_FOREGROUND | DISCL_NONEXCLUSIVE);    //and does not interfere with other apps using it
	if FAILED(hr) 
	{ 
	} 

	dKeyboard->Acquire();  //lastly we aquire the keyboard in order to use it
}

//this is a prelim function that hopefully will work in the future to get the keybaod state and pass it back to the application class
char Keyboard::getKeyboardState()
{
	char buffer[256];
	dKeyboard->GetDeviceState(sizeof(buffer),(LPVOID)&buffer);
	return buffer[256];
}

Keyboard::~Keyboard() //make sure to release both the keybard and the dinpute device
{
	if (dKeyboard)
	{
		dKeyboard->Unacquire();
		dKeyboard->Release();
	}

	if (dInput)
		dInput->Release();
}
