//the sprite function creates a sprite which can be used as a drawing surface
#include "Sprite.h"

Sprite::Sprite()
{
}

void Sprite::load(LPDIRECT3DDEVICE8 app_device) 
{
	D3DXCreateSprite(app_device,&app_Sprite); //in load we simply need the app device and pointer to sprite object
}

void Sprite::start(void) //since starting once and drawing takes less processing, we can class being using this
{
	app_Sprite->Begin();
}

void Sprite::end(void) //and then end using this function after allt he drawing is done
{
	app_Sprite->End();
}

//the most important sprite function is draw. the parameters we need are the texture, the scaling (d3dx8 has some sprite drawing
//problems that distort texture sizes), and the position
void Sprite::draw(LPDIRECT3DTEXTURE8 texture, D3DXVECTOR2 scaling, D3DXVECTOR2 translation)
{
	app_Sprite->Draw(texture,NULL,&scaling,&D3DXVECTOR2(0,0), NULL, &translation,0xFFFFFFFF);
}

Sprite::~Sprite() //always make sure to release the sprite before exiting
{
	app_Sprite->Release();
}
