//this specific texture class was made for scrolling and not scrolling textures and might be better off if
//split into two classes.
#include "Texture.h"

Texture::Texture()  //default the position to 0,0, top left of screen
{
	pos1.x = 0; pos1.y = 0;
	pos2 = pos1;
}

//in load we need the d3d device, the file name and the transparent color (though that is not yet working)
void Texture::load(LPDIRECT3DDEVICE8 app_device, LPSTR file_name, D3DCOLOR trans_color)
{
	//creating fromfileex allows for defintiion of a transparent color, but other stuff needs to be done in the
	//main program with alpha blending for this to work. we also pass the information so we can get the file info
	D3DXCreateTextureFromFileEx(app_device, file_name, 0, 0, 0, 0, D3DFMT_UNKNOWN, 
								D3DPOOL_MANAGED, D3DX_DEFAULT, D3DX_DEFAULT, trans_color, 
								&info, NULL, &app_texture);
	app_texture->GetLevelDesc(0,&desc);  //using this we can get the actual texture information
	vScaling.x=(float)info.Width/desc.Width; //then follow it up and get the proper scaling so images look how they are supposed to
	vScaling.y=(float)info.Height/desc.Height;
}

//we use this mainly for drawing textures to a sprite
LPDIRECT3DTEXTURE8 Texture::getTexture(void)
{
	return app_texture;
}

//increase the y values so the draw position changes and looks as if the image is scrolling vertically
void Texture::scroll(void)
{
	pos1.y+=.35;
	pos2.y+=.35;
}

//again, this is used for drawing to the sprite
D3DXVECTOR2 Texture::getScaling(void)
{
	return vScaling;
}

//incase you want to create a temporary information for calculations outside of this class
D3DXIMAGE_INFO Texture::getInfo(void)
{
	return info;
}

void Texture::setPos1(float x, float y)  //change the first position to the x and y
{
	pos1.x = x;
    pos1.y = y;
}

void Texture::setPos2(float x, float y)  //like above, but with pos2. two diff positions are used to creating a "never ending" image when scrolling
{
	pos2.x = x;
    pos2.y = y;
}

//getpos1 and getpos2 are used for drawing to the sprite
D3DXVECTOR2 Texture::getPos1(void)
{
	return pos1;
}

D3DXVECTOR2 Texture::getPos2(void)
{
	return pos2;
}

//used to determine where the image is and if it is off screen
float Texture::getPos1Y(void)
{
	return pos1.y;
}

float Texture::getPos2Y(void)
{
	return pos2.y;
}

//release the texture object
Texture::~Texture()
{
	app_texture->Release();
}
